Bug 199017 - dlopen() failures with gnucash-2.0.0-2.1
dlopen() failures with gnucash-2.0.0-2.1
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: gnucash (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Bill Nottingham
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2006-07-15 13:44 EDT by Tom London
Modified: 2014-03-16 23:00 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-07-26 10:12:03 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Tom London 2006-07-15 13:44:50 EDT
Description of problem:
running gnucash (gnucash-2.0.0-2.1, with a rawhide system) produces:

[tbl@localhost ~]$ gnucash

** (process:7363): WARNING **: Failed to dlopen()
'/usr/lib/gnucash/libgncmod-backend-file.la':
/usr/lib/gnucash/libgncmod-backend-file.so.0: undefined symbol:
DxaccAccountSetSecurity


** (process:7363): WARNING **: Failed to dlopen()
'/usr/lib/gnucash/libgncmod-app-file.la': libguile.so.12: cannot open shared
object file: No such file or directory


** (process:7363): WARNING **: Failed to dlopen()
'/usr/lib/gnucash/libgw-app-file.la': /usr/lib/gnucash/libgw-app-file.so.0:
undefined symbol: scm_thread_count



Version-Release number of selected component (if applicable):


How reproducible:
Every time

Steps to Reproduce:
1. run gnucash
2.
3.
  
Actual results:


Expected results:


Additional info:
Comment 1 Tom London 2006-07-16 17:26:21 EDT
Sorry, cut/paste error dropped the last few messages.  Error actually is 
gnucash: symbol lookup error: /usr/lib/libgdk-x11-2.0.so.0: undefined symbol:
g_type_register_static_simple

[tbl@localhost ~]$ gnucash

** (process:3803): WARNING **: Failed to dlopen()
'/usr/lib/gnucash/libgncmod-backend-file.la':
/usr/lib/gnucash/libgncmod-backend-file.so.0: undefined symbol:
DxaccAccountSetSecurity

** (process:3803): WARNING **: Failed to dlopen()
'/usr/lib/gnucash/libgncmod-app-file.la': libguile.so.12: cannot open shared
object file: No such file or directory


** (process:3803): WARNING **: Failed to dlopen()
'/usr/lib/gnucash/libgw-app-file.la': /usr/lib/gnucash/libgw-app-file.so.0:
undefined symbol: scm_thread_count


** (process:3803): WARNING **: Failed to dlopen()
'/usr/lib/gnucash/libgw-binary-import.la': libgncmod-binary-import.so.0: cannot
open shared object file: No such file or directory


** (process:3803): WARNING **: Failed to dlopen()
'/usr/lib/gnucash/libgw-gnome-search.la': libguile.so.12: cannot open shared
object file: No such file or directory

gnucash: symbol lookup error: /usr/lib/libgdk-x11-2.0.so.0: undefined symbol:
g_type_register_static_simple
[tbl@localhost ~]$ 

Comment 2 Bill Nottingham 2006-07-17 09:45:28 EDT
Does it error and run, or error and not run?
Comment 3 Tom London 2006-07-17 10:28:23 EDT
Sorry for not being clearer:

It errors and does not run.
Comment 4 Tom London 2006-07-25 15:21:05 EDT
OK.  I've figured this out a bit.

g_type_register_static_simple is now defined in /lib/libgobject-2.0.so.0,
supplied by glib2.

This library is not being loaded by gnucash.

Works if you startup gnucash with 'LD_PRELOAD=/lib/libgobject-2.0.so.0 gnucash'.

Still get a bunch of dlopen warnings, but the error about
g_type_register_static_simple goes away.

The following 'hack' to /usr/bin/gnucash 'fixes' this problem:
@@ -26,4 +26,4 @@
 export LD_LIBRARY_PATH
 export LTDL_LIBRARY_PATH
 
-LD_PRELOAD=/lib/libgobject-2.0.so.0 exec gnucash-bin "$@"
+exec gnucash-bin "$@"
Comment 5 Bill Nottingham 2006-07-25 15:31:01 EDT
What glib2 and gtk do you have installed?

Note, on my box:

[notting@nostromo: ~]$ ldd /usr/bin/gnucash-bin  | grep gob
        libgobject-2.0.so.0 => /lib/libgobject-2.0.so.0 (0x0026a000)
Comment 6 Tom London 2006-07-25 15:34:56 EDT
 ldd /usr/bin/gnucash-bin | grep gob 
        libgobject-2.0.so.0 => /lib/libgobject-2.0.so.0 (0x005ec000)


[root@localhost ~]# rpm -q gtk2
gtk2-2.10.1-1
[root@localhost ~]# rpm -q glib2
glib2-2.12.1-1

I believe this is Rawhide......

I am suffering prelink problems.  Could that be related?
Comment 7 Bill Nottingham 2006-07-25 16:01:47 EDT
Possibly. What happens if you do prelink --undo?
Comment 8 Tom London 2006-07-25 16:10:26 EDT
'prelink --undo' completes with no output (in about 1 second).

Afterwards, 'gnucash' crashes with same
gnucash: symbol lookup error: /usr/lib/libgdk-x11-2.0.so.0: undefined symbol:
g_type_register_static_simple
Comment 9 Bill Nottingham 2006-07-25 16:20:05 EDT
I'm baffled.

$ ldd /usr/lib/libgdk-x11-2.0.so.0 | grep gob
        libgobject-2.0.so.0 => /lib/libgobject-2.0.so.0 (0x00111000)

I see no way you could get this error. CC'ing gtk/glib people in case they have
any ideas.
Comment 10 Tom London 2006-07-25 17:18:57 EDT
OK, more on this....

Appears I have 2 copies of libgobject-2.0.so.0, an old copy (linked to
libgobject-2.0.so.0.1000.1) in /usr/lib, and a new copy (linked to
libgobject-2.0.so.0.1200.1) in /lib.

'Removing' the old ones in /usr/lib seems to have solved this.

Sorry for the false alarm.

I'll let this settle for a day and then close as NOTABUG.
Comment 11 Tom London 2006-07-25 17:40:31 EDT
I suspect this is a Rawhide related update issue.

Checking shows I have 'duplicate' or 'stale' copies of libglib, libgmodule,
libgobject, and libgthread.

All the old ones are -2.0.so.0.1000.1; all the new ones are -2.0.so.0.1200.1. So
some Rawhide update probably failed to cleanup properly.

Again, sorry for the false alarm.

Note You need to log in before you can comment on or make changes to this bug.